program TChartTestService;

{$ifdef DEBUG}
  {$APPTYPE CONSOLE}
{$endif}

uses
  Vcl.SvcMgr,
  mySvc in 'mySvc.pas' {TChartTestSrv: TService},
  TestThread in 'TestThread.pas',
  System.SysUtils;

var MyDummyBoolean: Boolean;
{$R *.RES}
begin
  {$ifdef DEBUG}
  try
    // In debug mode the server acts as a console application.
    WriteLn('TChartTestSrv DEBUG mode. Creating service');

    // Create the TService descendant manually.
    TChartTestSrv := TTChartTestSrv.Create(nil);

    // Simulate service start.
    WriteLn('Starting service...');
    TChartTestSrv.ServiceStart(TChartTestSrv, MyDummyBoolean);

    // Keep the console box running (ServerContainer1 code runs in the background)
    ReadLn;

    // On exit, destroy the service object.
    FreeAndNil(TChartTestSrv);
  except
    on E: Exception do
    begin
      Writeln(E.ClassName, ': ', E.Message);
      WriteLn('Press enter to exit.');
      ReadLn;
    end;
  end;
  {$else}
  // Run as a true windows service (release).
  // Fr Windows 2003 Server muss StartServiceCtrlDispatcher vor
  // CoRegisterClassObject aufgerufen werden, das indirekt von
  // Application.Initialize aufgerufen werden kann. TServiceApplication.DelayInitialize
  // ermglicht, dass Application.Initialize von TService.Main (nach
  // StartServiceCtrlDispatcher) aufgerufen werden kann.
  //
  // Eine verzgerte Initialisierung des Application-Objekts kann sich auf
  // Ereignisse auswirken, die dann vor der Initialisierung ausgelst werden,
  // wie z.B. TService.OnCreate. Dies wird nur empfohlen, wenn ServiceApplication
  // ein Klassenobjekt bei OLE registriert und fr die Verwendung mit
  // Windows 2003 Server vorgesehen ist.
  //
  // Application.DelayInitialize := True;
  //
  if not Application.DelayInitialize or Application.Installing then
    Application.Initialize;
  Application.CreateForm(TTChartTestSrv, TChartTestSrv);
  Application.Run;
  {$endif}
end.
